<div class="all-players">
    {#if $players.length > 0}
        <input type="text" placeholder="Filter Players" bind:value=filter />
        <div class="players">
            {#each filteredPlayers as player}
                <PlayerCard {player} />
            {:else}
                <h2>No players match the filter</h2>
            {/each}
        </div>
    {:else}
        <h1>Loading Players</h1>
    {/if}
</div>

<style>
.all-players {
    position: relative;
    display: flex;
    flex-direction: column;
    height: 100%;
    max-width: 1024px;
    margin: 0 auto;
}
.players {
    overflow-y: auto;
}
</style>

<script>
    import { AppStore } from '../App.store';
    import { Api } from '../api';

    export default {
        store: () => AppStore,
        data: () => ({ filter: '' }),
        oncreate() {
            if (this.store.get().players.length === 0) {
                Api.getAllPlayers().then(players => {
                    this.store.set({ players });
                });
            }
        },
        computed: {
            filteredPlayers: ({ $players, filter }) => $players.filter(p => p.name.includes(filter) || p.id.includes(filter) || p.team.includes(filter)),
        },
        components: {
            PlayerCard: './PlayerCard',
        }
    }
</script>